// AdvServerDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Donkey.h"
#include "AdvServerDlg.h"
#include "IniFile.h"
#include "Primnumber.h"

#include "DonkeyDlg.h"
#include "DonkeyCmd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CAdvServerDlg 


CAdvServerDlg::CAdvServerDlg(CWnd* pParent /*=NULL*/)
	: CPropDlg(CAdvServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdvServerDlg)
	m_MaxVersion	= 9999;
	m_MinVersion	= 60;
	m_RoomName		= _T("");
	m_Logfile		= FALSE;
	m_Clear			= FALSE;
	m_Keysearch		= FALSE;
	m_HardLimit		= 1001;
	m_SoftLimit		= 1000;
	m_LowIdPercent	= 30;
	m_bZlib			= TRUE;
	m_bLowIds		= FALSE;
	m_strTableSize	= _T("");
	m_strThreads	= _T("");
	m_CompLevel		= 9;
	m_MinEMule		= 24;
	m_strCPU = _T("");
	m_ZlibOnly = FALSE;
	m_rdL1Cache = -1;
	//}}AFX_DATA_INIT

	m_bIsPentium = false;
	m_bIsPIV	 = false;
}


void CAdvServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvServerDlg)
	DDX_Control(pDX, IDC_CLEAR, m_ClearCtrl);
	DDX_Control(pDX, IDC_ROOMS, m_Rooms);
	DDX_Control(pDX, IDC_TITEL, m_Titel);
	DDX_Text(pDX, IDC_MAXVERSION, m_MaxVersion);
	DDV_MinMaxUInt(pDX, m_MaxVersion, 60, 9999);
	DDX_Text(pDX, IDC_MINVERSION, m_MinVersion);
	DDV_MinMaxUInt(pDX, m_MinVersion, 60, 99);
	DDX_Text(pDX, IDC_ROOM, m_RoomName);
	DDX_Check(pDX, IDC_LOGFILE, m_Logfile);
	DDX_Check(pDX, IDC_CLEAR, m_Clear);
	DDX_Check(pDX, IDC_KEYSEARCH, m_Keysearch);
	DDX_Text(pDX, IDC_ED_HARD, m_HardLimit);
	DDV_MinMaxUInt(pDX, m_HardLimit, 200, 5000);
	DDX_Text(pDX, IDC_ED_SOFT, m_SoftLimit);
	DDV_MinMaxUInt(pDX, m_SoftLimit, 200, 5000);
	DDX_Text(pDX, IDC_ED_LOWIDPERCENT, m_LowIdPercent);
	DDV_MinMaxUInt(pDX, m_LowIdPercent, 10, 100);
	DDX_Check(pDX, IDC_CHK_ZLIB, m_bZlib);
	DDX_Check(pDX, IDC_CHK_LOWID, m_bLowIds);
	DDX_Text(pDX, IDC_TABLESIZE, m_strTableSize);
	DDX_Text(pDX, IDC_THREADS, m_strThreads);
	DDX_Text(pDX, IDC_ED_COMP, m_CompLevel);
	DDV_MinMaxUInt(pDX, m_CompLevel, 0, 9);
	DDX_Text(pDX, IDC_MINEMULE, m_MinEMule);
	DDV_MinMaxUInt(pDX, m_MinEMule, 24, 99);
	DDX_Text(pDX, IDC_ED_CPU, m_strCPU);
	DDX_Check(pDX, IDC_CHK_ZLIBONLY, m_ZlibOnly);
	DDX_Radio(pDX, IDC_RD_L1_16, m_rdL1Cache);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvServerDlg, CPropDlg)
	//{{AFX_MSG_MAP(CAdvServerDlg)
	ON_BN_CLICKED(IDC_PRIMNUMBER, OnPrimnumber)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_BN_CLICKED(IDC_LOGFILE, OnLogfile)
	ON_EN_KILLFOCUS(IDC_ED_COMP, OnKillfocusEdComp)
	ON_EN_KILLFOCUS(IDC_ED_HARD, OnKillfocusEdHard)
	ON_EN_KILLFOCUS(IDC_ED_SOFT, OnKillfocusEdSoft)
	ON_EN_KILLFOCUS(IDC_MAXVERSION, OnKillfocusMaxversion)
	ON_EN_KILLFOCUS(IDC_MINVERSION, OnKillfocusMinversion)
	ON_EN_KILLFOCUS(IDC_MINEMULE, OnKillfocusMinemule)
	ON_BN_CLICKED(IDC_RD_L2_PIII, OnRdL2PIII)
	ON_BN_CLICKED(IDC_CHK_ZLIB, OnChkZlib)
	ON_BN_CLICKED(IDC_RD_L1_16, OnRdL1Cache)
	ON_BN_CLICKED(IDC_BTN_UPDLOWID, OnBtnUpdlowid)
	ON_BN_CLICKED(IDC_BTN_UPDLIMITS, OnBtnUpdLimits)
	ON_BN_CLICKED(IDC_RD_L2_PIV, OnRdL2PIII)
	ON_BN_CLICKED(IDC_RD_L1_64, OnRdL1Cache)
	ON_BN_CLICKED(IDC_RD_L1_132, OnRdL1Cache)
	ON_BN_CLICKED(IDC_RD_L1_128, OnRdL1Cache)
	ON_BN_CLICKED(IDC_BTN_UPDZLIB, OnBtnUpdZlib)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CAdvServerDlg 

BOOL CAdvServerDlg::OnInitDialog() 
{
	CPropDlg::OnInitDialog();
	
	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TITEL);

	m_L1_cache_size = 16;
	
	m_strCPU = m_CpuInfo.GetExtendedProcessorName();
	
	if (m_strCPU.Find("Pentium") != -1)
	{
		m_bIsPentium = true;
	}

	if (m_bIsPentium)
	{
		if (m_strCPU.Find("III") != -1)
		{
			m_bIsPIV = false;
			m_rdL1Cache = 1;
		}
		else
		{
			m_bIsPIV = true;
			m_rdL1Cache = 3;
		}
	}
	else // assume Athlon
	{
		if (m_strCPU.Find("XP") != -1)	// Athlon XP
		{
			m_bIsPIV = true;
			m_rdL1Cache = 2;
		}
		else
		{
			m_bIsPIV = false;
		}
	}

	/* dcache_line (integer) 
	 *	This controls the alignment of memory blocks that eserver users to store 
	 *  file descriptions. 
	 *  Trying to use the L1 cache size of the CPU helps the performance, but may 
	 *  consume more ram. 
	 *  The L1 cache size of PII & PIII is 32 bytes. 
	 *  For Athlons and P4, this is 64 bytes. Default value : system dependant
	 */

	if (m_bIsPIV)
	{
		CheckRadioButton(IDC_RD_L2_PIII, IDC_RD_L2_PIV, IDC_RD_L2_PIV);
		//CheckRadioButton(IDC_RD_L1_16, IDC_RD_L1_128, IDC_RD_L1_128);
	}
	else
	{
		CheckRadioButton(IDC_RD_L2_PIII, IDC_RD_L2_PIV, IDC_RD_L2_PIII);
	}

	UpdateData(false);

	OnRdL2PIII();
	
	switch (m_rdL1Cache) 
	{
	case 0:
		m_L1_cache_size = 16;
		break;
	case 1:
		m_L1_cache_size = 32;
		break;
	case 2:
		m_L1_cache_size = 64;
		break;
	case 3:
		m_L1_cache_size = 128;
		break;
	default:
		m_L1_cache_size = 32;
	}

	return TRUE;
}

// Load
// Laden der Einstellungen
void CAdvServerDlg::Load()
{
	CIniFile ini;
	ini.SetPath("donkey.ini");

	if (ini.ReadFile())
	{
		m_MinVersion = ini.GetValueI("server","minVersion","60");
		if (m_MinVersion < 60)
		{
			MessageBox("MinVersion too small, reset to 60");
			m_MaxVersion = 60;
		}
		if (m_MinVersion > 99)
		{
			MessageBox("MinVersion too big, reset to 60");
			m_MaxVersion = 60;
		}

		m_MaxVersion = ini.GetValueI("server","maxVersion","9999");
		if (m_MaxVersion < 60)
		{
			MessageBox("MaxVersion too small, reset to 9999");
			m_MaxVersion = 9999;

		}
		if (m_MaxVersion > 9999)
		{
			MessageBox("MaxVersion too big, reset to 9999");
			m_MaxVersion = 9999;
		}

		m_strTableSize	 = "auto";
		m_strThreads     = "auto";
		CString minE	 = ini.GetValue("server","minEVersion", "0x24");

		m_MinEMule = atoi((LPCSTR)minE.Mid(2)) ;
		if (m_MinEMule < 24)
		{
			MessageBox("minEVersion too small, reset to 24");
			m_MinEMule = 24;
		}
		
		if (m_MinEMule > 99)
		{
			MessageBox("minEVersion too big, reset to 99");
			m_MinEMule = 99;
		}

		m_HardLimit  = ini.GetValueI("server","hardLimit", "1001");
		if (m_HardLimit < 200)
		{
			MessageBox("hardLimit too small, reset to 200");
			m_HardLimit = 200;
		}

		if (m_HardLimit > 5000)
		{
			MessageBox("hardLimit too big, reset to 5000");
			m_HardLimit = 5000;
		}

		m_SoftLimit  = ini.GetValueI("server","softLimit", "1000");
		if (m_HardLimit < 200)
		{
			MessageBox("softLimit too small, reset to 200");
			m_SoftLimit = 200;
		}

		if (m_HardLimit > 5000)
		{
			MessageBox("softLimit too big, reset to 5000");
			m_SoftLimit = 5000;
		}

		if (m_SoftLimit > m_HardLimit)
		{
			MessageBox("adapted SoftLimit to HardLimit");
			m_SoftLimit = m_HardLimit;
		}

		m_bZlib		 = (ini.GetValue("server","zlib_enable", "true") == "true");
		m_CompLevel	 = ini.GetValueI("server","zlib_complevel", "9");
		if ((m_CompLevel < 0) || (m_CompLevel > 10))
		{
			MessageBox("zlib_complevel invalid, reset 9");
			m_CompLevel = 9;
		}
		m_ZlibOnly	 = (ini.GetValue("server","only_zlib_clients", "false") == "true");

		if (!m_bZlib)
		{
			GetDlgItem(IDC_CHK_ZLIBONLY)->EnableWindow(false);
		}

		m_bLowIds	 = ini.GetValueI("server","LOWIDenable","0");
		m_LowIdPercent = ini.GetValueI("server","LOWIDpercent", "30");
		if ((m_LowIdPercent < 0) || (m_LowIdPercent > 100))
		{
			MessageBox("LOWIDpercent invalid, reset 30");
			m_CompLevel = 30;
		}
	
		m_dcache_line	= ini.GetValueI("server", "dcache_line", "32");

		CString defL1;
		defL1.Format("%d", m_L1_cache_size);
		m_L1_cache_size = ini.GetValueI("server", "L1_cache_size", defL1				);
		switch(m_L1_cache_size)
		{
		case 16:
			m_rdL1Cache = 0;
			break;
		case 32:
			m_rdL1Cache = 1;
			break;
		case 64:
			m_rdL1Cache = 2;
			break;
		case 128:
			m_rdL1Cache = 3;
			break;
		default:
			m_rdL1Cache = 1;
			m_L1_cache_size = 32;
		}

		m_Keysearch  = (ini.GetValue("server","type","key") == "key");
		m_Logfile	 = (ini.GetValue("server","logFile","false") == "true");
		m_Clear		 = (ini.GetValue("Control","clear","false") == "true");
			
/*		while (m_Rooms.GetCount() > 0) m_Rooms.DeleteString(0);
		
		int count = 0;
		CString strCount; strCount.Format("room[%i]",count++);
			
		while (ini.FindValue(ini.FindKey("server"),strCount) > -1)
		{			
			m_Rooms.AddString(ini.GetValue("server",strCount,""));			
			strCount.Format("room[%i]",count++);
		}
*/
		UpdateData(FALSE);

		OnLogfile();
	}
}

// Save
// Speichern der Einstellungen
void CAdvServerDlg::Save()
{
	CIniFile ini;
	ini.SetPath("donkey.ini");
	ini.ReadFile();

	UpdateData();

	ini.SetValueI("server","minVersion",m_MinVersion);
	ini.SetValueI("server","maxVersion",m_MaxVersion);
//	ini.SetValueI("server","tableSize",m_TableSize);
//	ini.SetValueI("server","threads",m_Threads);

	CString minE;
	minE.Format("0x%02d", m_MinEMule);
	ini.SetValue("server","minEVersion", minE);

	ini.SetValueI("server","hardLimit",m_HardLimit);
	ini.SetValueI("server","softLimit",m_SoftLimit);

	ini.SetValue("server","type",(m_Keysearch) ? "key" : "substring");
	ini.SetValue("server","logFile",(m_Logfile) ? "true" : "false");

	ini.SetValue("server","zlib_enable",(m_bZlib) ? "true" : "false");
	ini.SetValueI("server","zlib_complevel",m_CompLevel);
	ini.SetValue("server","only_zlib_clients",(m_ZlibOnly) ? "true" : "false");
	
	ini.SetValueI("server", "dcache_line", m_dcache_line);
	ini.SetValueI("server", "L1_cache_size", m_L1_cache_size);

	ini.SetValueI("server","LOWIDenable",  m_bLowIds);
	ini.SetValueI("server","LOWIDpercent",m_LowIdPercent);

	ini.SetValue("Control","clear",(m_Clear) ? "true" : "false");

/*
	CString room;
	CString text;	
	
	// alle Chatrooms lschen
	int i = 0;
	room.Format("room[%i]",i);
	while (ini.FindValue(ini.FindKey("server"),room) != -1) 
	{
		ini.DeleteValue("server",room);
		room.Format("room[%i]",++i);
	}

	// Chatrooms neu anlegen
	for (i = 0; i < m_Rooms.GetCount(); i++)
	{
		room.Format("room[%i]",i);
		m_Rooms.GetText(i,text);		
		ini.SetValue("server",room,text);
	}
*/
	ini.WriteFile();
}

// OnPrimnumber
// Klick auf "Primnumber" : Nchst kleiner Primzahl generieren
void CAdvServerDlg::OnPrimnumber() 
{
	UpdateData();
	
	CPrimnumber prim;

//	m_TableSize = prim.GetPrevPrimnumber(m_TableSize);

	UpdateData(FALSE);
}

// OnAdd
// Klick auf "+" : Chartoom hinzufgen
void CAdvServerDlg::OnAdd() 
{
//	UpdateData();

	AfxMessageBox("not supported by 16.40");

//	m_Rooms.AddString(m_RoomName);

	m_RoomName = "";
//	UpdateData(FALSE);	
}

// OnDel
// Klick auf "-" : Chartoom entfernen
void CAdvServerDlg::OnDel() 
{
	if (m_Rooms.GetCurSel() != LB_ERR)
		m_Rooms.DeleteString(m_Rooms.GetCurSel());
}

// OnLogfile
// Toggle "Write logfile"
void CAdvServerDlg::OnLogfile() 
{
	UpdateData();

	m_ClearCtrl.EnableWindow(m_Logfile);
}

void CAdvServerDlg::OnKillfocusEdComp() 
{
	UpdateData();
}

void CAdvServerDlg::OnKillfocusEdHard() 
{
	UpdateData();
	if (m_SoftLimit > m_HardLimit)
	{
		MessageBox("adapted SoftLimit to HardLimit");
		m_SoftLimit = m_HardLimit;
		UpdateData(false);
	}
}

void CAdvServerDlg::OnKillfocusEdSoft() 
{
	UpdateData();
	if (m_SoftLimit > m_HardLimit)
	{
		MessageBox("adapted SoftLimit to HardLimit");
		m_SoftLimit = m_HardLimit;
		UpdateData(false);
	}
}

void CAdvServerDlg::OnKillfocusMaxversion() 
{
	UpdateData();
}

void CAdvServerDlg::OnKillfocusMinversion() 
{
	UpdateData();
}

void CAdvServerDlg::OnKillfocusMinemule() 
{
	UpdateData();
}

void CAdvServerDlg::OnRdL2PIII() 
{
	if (IsDlgButtonChecked(IDC_RD_L2_PIII))
	{
		m_dcache_line = 32;
	}
	else
	{
		m_dcache_line = 64;
	}
}


void CAdvServerDlg::OnChkZlib() 
{
	UpdateData(true);

	if (!m_bZlib)
	{
		GetDlgItem(IDC_CHK_ZLIBONLY)->EnableWindow(false);
	}
	else
	{
		GetDlgItem(IDC_CHK_ZLIBONLY)->EnableWindow(true);
	}	
}

void CAdvServerDlg::OnRdL1Cache() 
{
	UpdateData(true);

	switch(m_rdL1Cache)
	{
	case 0:
		m_L1_cache_size = 16;
		break;
	case 1:
		m_L1_cache_size = 32;
		break;
	case 2:
		m_L1_cache_size = 64;
		break;
	case 3:
		m_L1_cache_size = 128;
		break;
	}
}


void CAdvServerDlg::OnBtnUpdlowid() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	if (!cmd->IsChildRunning())
	{
		AfxMessageBox("eServer is not running");
		return;
	}

	UpdateData();

	CString parms;
	if (m_bLowIds)
	{
		parms ="LOWIDenable=true\n";
	}
	else
	{
		parms ="LOWIDenable=false\n";
	}

	cmd->Execute(parms,this->m_hWnd);

	parms.Format("LOWIDpercent=%d", m_LowIdPercent);

	cmd->Execute(parms,this->m_hWnd);

	Sleep(500);

//	cmd->Execute("vo all",this->m_hWnd);

	GetDlgItem(IDC_ROOM)->SetWindowText("updated LowID parameters");
}

void CAdvServerDlg::OnBtnUpdLimits() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	if (!cmd->IsChildRunning())
	{
		AfxMessageBox("eServer is not running");
		return;
	}

	UpdateData();

	CString parms;

	parms.Format("hardLimit=%d", m_HardLimit);
	cmd->Execute(parms, this->m_hWnd);

	parms.Format("softLimit=%d", m_SoftLimit);
	cmd->Execute(parms, this->m_hWnd);

	Sleep(500);

	// cmd->Execute("vo all",this->m_hWnd);
	GetDlgItem(IDC_ROOM)->SetWindowText("updated Limit parameters");
}

void CAdvServerDlg::OnBtnUpdZlib() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	if (!cmd->IsChildRunning())
	{
		AfxMessageBox("eServer is not running");
		return;
	}

	UpdateData();

	CString parms;

	if (m_bZlib)
	{
		parms ="zlib_enable=true";
	}
	else
	{
		parms ="zlib_enable=false";
	}
	cmd->Execute(parms, this->m_hWnd);

	if (m_ZlibOnly)
	{
		parms ="only_zlib_clients=true";
	}
	else
	{
		parms ="only_zlib_clients=false";
	}
	cmd->Execute(parms, this->m_hWnd);

	parms.Format("zlib_complevel=%d", m_CompLevel);
	cmd->Execute(parms, this->m_hWnd);

	Sleep(500);

//	cmd->Execute("vo all",this->m_hWnd);
	GetDlgItem(IDC_ROOM)->SetWindowText("updated zlib parameters");
}
