// DialupDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "donkey.h"
#include "DialupDlg.h"
#include "IniFile.h"
#include <ras.h>
#include <raserror.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDialupDlg 


CDialupDlg::CDialupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDialupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialupDlg)
	//}}AFX_DATA_INIT
}


void CDialupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialupDlg)
	DDX_Control(pDX, IDC_COMBO, m_Liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialupDlg, CDialog)
	//{{AFX_MSG_MAP(CDialupDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDialupDlg 

BOOL CDialupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TEXT);
	this->SetWindowText(Lang.GetStr(38));

	CIniFile ini;
	ini.SetPath("donkey.ini");
	ini.ReadFile();

	// Eintrag "Phonebookentry" lesen
	CString entry = ini.GetValue("Control","Entry","No automatic redial");
	
	// Alle Telefonbucheintrge lesen und in die ComboBox schreiben
	RASENTRYNAME renDmy,*pRen;
	DWORD dw,dwSize,dwEntries,dwResult;
	
	dwSize = sizeof(RASENTRYNAME);
	renDmy.dwSize = sizeof(RASENTRYNAME);
	dwResult = RasEnumEntries(NULL,NULL,&renDmy,&dwSize,&dwEntries);
			
	if (!dwEntries || (dwResult && dwResult != ERROR_BUFFER_TOO_SMALL))
	{
		m_Liste.EnableWindow(FALSE);
		return TRUE;
		
	}
	
	pRen = new RASENTRYNAME[dwEntries];
	pRen[0].dwSize = sizeof(RASENTRYNAME);
	dwResult = RasEnumEntries(NULL,NULL,pRen,&dwSize,&dwEntries);
	
	if(dwResult)
	{
		delete [] pRen;
		m_Liste.EnableWindow(FALSE);
		return TRUE;
	}
	
	for(dw = 0; dw < dwEntries; dw++)		
	{
		m_Liste.AddString(pRen[dw].szEntryName);
	}
	
	delete [] pRen;

	// Gespeicherten Eintrag auswhlen
	int sel;
	if ((sel = m_Liste.FindString(0,entry)) != LB_ERR)
		m_Liste.SetCurSel(sel);
	
	return TRUE;  
}

void CDialupDlg::OnOK() 
{
	CIniFile ini;
	ini.SetPath("donkey.ini");
	ini.ReadFile();

	// ausgewhlten Eintrag sichern
	CString entry; m_Liste.GetLBText(m_Liste.GetCurSel(), entry);
	ini.SetValue("Control","Entry",entry);

	ini.WriteFile();

	CDialog::OnOK();
}
