// DonkeyCmd.cpp: Implementierung der Klasse CDonkeyCmd.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "Donkey.h"
#include "DonkeyCmd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

time_t CDonkeyCmd::StartupTime;

CDonkeyCmd::CDonkeyCmd()
{
	output = tmpOut = "";
	ThreadStruct.alive = false;
}

CDonkeyCmd::~CDonkeyCmd()
{

}

// Start
// Starten des Child-Prozesses
void CDonkeyCmd::Start()
{
	CDonkeyApp* pApp = (CDonkeyApp*)AfxGetApp();

	if (!StartChildProcess(pApp->m_ServerExe, FALSE))
		AfxMessageBox("Kann eserver nicht starten");
	else time(&StartupTime);
}

// Stop
// Beenden des Childprozesses
void CDonkeyCmd::Stop()
{
	if (IsChildRunning()) 
	{
		// this does not work in 16.41
		// WriteChildStdIn("q\ny\n");

		WriteChildStdIn("quit\n");

		// "Stopping server"-Dialog anzeigen
		stopDlg.DoModal();			
	}
}

void CDonkeyCmd::OnChildStarted(LPCSTR lpszCmdLine)
{

}

// OnChildStdOutWrite
// Wird aufgerufen, wenn der Child-Prozess eine neue Ausgabe schreibt
void CDonkeyCmd::OnChildStdOutWrite(LPCSTR lpszOutput)
{
/*
	int pos;
	CString str = lpszOutput;

	while ((pos = str.Find("\r")) > 0)
	{
		tmpOut+= str.Left(pos);
		str = str.Mid(pos + 2);
	}
*/
	TRACE("%s\n", lpszOutput);

	output += lpszOutput;


/*
	tmpOut+= lpszOutput;

	// Neuer Prompt => Zeichenkette abgeschlossen
	int pos = -1;
	if ((pos = tmpOut.Find("> ")) != -1)
	{
		output = tmpOut.Left(pos);
		tmpOut.Delete(0,pos + 2);
	}	
*/

//	TRACE("CDonkeyCmd::OnChildStdOutWrite done, output.len = %d\n",
//		output.GetLength());
}

// OnChildStdErrWrite
// Wird aufgerufen, wenn der Child-Prozess eine neue Fehlermeldung schreibt
void CDonkeyCmd::OnChildStdErrWrite(LPCSTR lpszOutput)
{
	AfxMessageBox(lpszOutput);
}

// OnChildTerminate
// Wird aufgerufen, wenn der Child-Prozess beendet wurde
void CDonkeyCmd::OnChildTerminate()
{
	if (stopDlg.m_hWnd) stopDlg.OnCancel();
}

// Execute
// Sendet ein Kommando an den Child-Prozess
// in :
// - cmd : Kommando
// - hWnd : Handle auf das Fenster, welches eine Nachricht nach erfolreicher Ausfhrung
//			des Kommandos erhalten soll		    
bool CDonkeyCmd::Execute(CString cmd, HWND hWnd)
{
	// Thread luft noch
	if (ThreadStruct.alive) return false;

	ThreadStruct.command = cmd;
	ThreadStruct.hWnd = hWnd;
	ThreadStruct.pDonkey = this;

	DWORD dwThreadID;

	// Letzte Ausgabe lschen
	output.Empty();

	m_hThread = ::CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteThread,	
							  (LPVOID)&ThreadStruct, 0, &dwThreadID);	

	return true;
}

// ExecuteThread
// Thread wartet auf Beendigung des Kommandos
int CDonkeyCmd::ExecuteThread(THREADSTRUCT* pThreadStruct)
{
	// Kommando absetzen
	pThreadStruct->pDonkey->WriteChildStdIn(pThreadStruct->command + "\n");

	Sleep(500);
	// Warten auf nchsten Prompt
	while (pThreadStruct->pDonkey->output.IsEmpty()) 
	{
		Sleep(200);
	}

	// Nachrcht senden
	if (pThreadStruct->hWnd)
		::SendMessage(pThreadStruct->hWnd, WM_DONKEY,(LPARAM)&pThreadStruct->pDonkey->output,0);

	pThreadStruct->alive = false;

	return 0;
}

time_t CDonkeyCmd::GetStartupTime()
{
	return StartupTime;
}