// DonkeyDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Donkey.h"
#include "DonkeyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char* TrayNotificationMsg = "DonkeyControl tray notification";
const UINT WM_TASKBARCREATED = ::RegisterWindowMessage(_T("TaskbarCreated"));

/////////////////////////////////////////////////////////////////////////////
// CDonkeyDlg Dialogfeld

CDonkeyDlg::CDonkeyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDonkeyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDonkeyDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pActive = NULL;

	bMinimized = false;
	pTrayIcon = NULL;
	nTrayNotificationMsg = RegisterWindowMessage(TrayNotificationMsg);
}

void CDonkeyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDonkeyDlg)
	DDX_Control(pDX, IDC_TEMPLATE, m_Template);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDonkeyDlg, CDialog)
	//{{AFX_MSG_MAP(CDonkeyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_COMMAND(ID_SYSTRAY_RESTORE, OnSystrayRestore)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_OUTBAR_NOTIFY, OnOutbarNotify)
	ON_REGISTERED_MESSAGE(WM_TASKBARCREATED, OnTaskbarCreated)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDonkeyDlg Nachrichten-Handler

BOOL CDonkeyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// Alle Unterdialoge erstellen und initialisieren
	CRect rect;
	
	// Unterdialoge auf "IDC_TEMPLATE" positionieren
	m_Template.GetWindowRect(&rect);
	ScreenToClient(&rect);

	m_ServerDlg.Create(IDD_SERVER, this);    
	m_ServerDlg.Load();
	m_ServerDlg.MoveWindow(rect);

	m_AdvServerDlg.Create(IDD_ADV_SERVER, this);    
	m_AdvServerDlg.Load();
	m_AdvServerDlg.MoveWindow(rect);

	m_UserDlg.Create(IDD_USERS,this);    
	m_UserDlg.Load();
	m_UserDlg.MoveWindow(rect);

	m_KnownServersDlg.Create(IDD_KNOWN_SERVERS,this);    
	m_KnownServersDlg.Load();
	m_KnownServersDlg.MoveWindow(rect);

	m_StatsDlg.Create(IDD_STATS,this);    
	m_StatsDlg.Load();
	m_StatsDlg.MoveWindow(rect);

	m_InfoDlg.Create(IDD_INFO,this);    
	m_InfoDlg.Load();
	m_InfoDlg.MoveWindow(rect);

	// 1. Dialog anzeigen	
	ShowDlg(0);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CDonkeyDlg::SetupTrayIcon()
{
	if (bMinimized && (pTrayIcon == NULL)) 
	{
		pTrayIcon = new CSystemTray;
		pTrayIcon->Create(0, nTrayNotificationMsg, "Donkey Control", m_hIcon, IDR_SYSTRAY_MENU);
	}
	else 
	{
		delete pTrayIcon;
		pTrayIcon = NULL;
	}
}

void CDonkeyDlg::SetupTaskBarButton()
{	
	if (bMinimized) ShowWindow(SW_HIDE);
	else ShowWindow(SW_SHOW);
}

void CDonkeyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	// Decide if minimize state changed
	bool bOldMin = bMinimized;
	if (nID == SC_MINIMIZE) 
	{
		bMinimized = true;
	}
	else if (nID == SC_RESTORE) 
	{
		bMinimized = false;
	}

	CDialog::OnSysCommand(nID, lParam);

	if (bOldMin != bMinimized) 
	{
		// Minimize state changed.  Create the systray icon and do 
		// custom taskbar button handling.
		SetupTrayIcon();
		SetupTaskBarButton();
	}
}

void CDonkeyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CDonkeyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CDonkeyDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CRect rect;
	GetClientRect(&rect);
		
	// ToolBar einrichten
	m_wndBar.Create(WS_CHILD | WS_VISIBLE, CRect(0, 0, 120, rect.Height()), this, IDD_DONKEY_DIALOG); 
	
	m_wndBar.SetOwner(this); 

	CBitmap img;
	img.LoadBitmap(IDB_IMAGELIST);
	imgSmall.Create(32,32,ILC_COLOR24 | ILC_MASK,2,10);
	imgSmall.Add(&img, RGB(255,0,255));
	img.DeleteObject();
	
	m_wndBar.SetAnimationTickCount(0); 
	m_wndBar.SetAnimSelHighlight(0); 
	m_wndBar.SetImageList(&imgSmall, CGfxOutBarCtrl::fLargeIcon); 
	
	m_wndBar.AddFolder("Einstellungen", 0); 
	m_wndBar.InsertItem(0, 0, Lang.GetStr(48), 0, 0);
	m_wndBar.InsertItem(0, 1, Lang.GetStr(49), 1, 0);
	m_wndBar.InsertItem(0, 2, Lang.GetStr(50), 2, 0);
	m_wndBar.InsertItem(0, 3, Lang.GetStr(51), 5, 0);
	m_wndBar.InsertItem(0, 4, Lang.GetStr(52), 3, 0);
	m_wndBar.InsertItem(0, 5, Lang.GetStr(53), 4, 0);
	
	m_wndBar.SetSelFolder(0);
	
	return 0;
}

void CDonkeyDlg::ShowDlg(int id)
{
	HideAll();

	switch (id)
	{
	case 0:
		{
			m_pActive = (CServerDlg*)&m_ServerDlg;
			m_ServerDlg.SetActive();			
			break;
		}
	case 1:
		{
			m_pActive = (CAdvServerDlg*)&m_AdvServerDlg;
			m_AdvServerDlg.SetActive();			
			break;
		}
	case 2:
		{
			m_pActive = (CUserDlg*)&m_UserDlg;
			m_UserDlg.SetActive();			
			break;
		}
	case 3:
		{
			m_pActive = (CKnownServersDlg*)&m_KnownServersDlg;
			m_KnownServersDlg.SetActive();	
			break;
		}
	case 4:
		{
			m_pActive = (CStatsDlg*)&m_StatsDlg;
			m_StatsDlg.SetActive();			
			break;
		}
	case 5:
		{
			m_pActive = (CInfoDlg*)&m_InfoDlg;
			m_InfoDlg.SetActive();			
			break;
		}
	}
}

void CDonkeyDlg::HideAll()
{
	m_ServerDlg.SetInactive();
	m_AdvServerDlg.SetInactive();
	m_UserDlg.SetInactive();
	m_KnownServersDlg.SetInactive();
	m_StatsDlg.SetInactive();
	m_InfoDlg.SetInactive();
	m_pActive = NULL;
}


long CDonkeyDlg::OnOutbarNotify(WPARAM wParam, LPARAM lParam)
{
	switch (wParam)
	{
		case NM_OB_ITEMCLICK:
			{
				ShowDlg((int)lParam);		
			}		
	}
	
	return 0;
}

void CDonkeyDlg::OnCancel()
{
	if (m_pActive) m_pActive->Save();

	// eDonkey-Server stoppen
	if (m_Donkey.IsChildRunning()) m_Donkey.Stop();	

	CDialog::OnCancel();
}

void CDonkeyDlg::OnOK()
{
}

void CDonkeyDlg::OnSystrayRestore() 
{
	ShowWindow(SW_RESTORE);
	bMinimized = false;
	SetupTrayIcon();
	SetupTaskBarButton();	
}

LRESULT CDonkeyDlg::OnTaskbarCreated(WPARAM wp, LPARAM lp)
{
	if (pTrayIcon) 
	{
		pTrayIcon->HideIcon();
		pTrayIcon->ShowIcon();
	}

	return 0;
}
