// KnownServersDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "donkey.h"
#include "KnownServersDlg.h"
#include "DonkeyDlg.h"
#include "DonkeyCmd.h"
#include "TokenEx.h"
#include "winsock2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CKnownServersDlg 


CKnownServersDlg::CKnownServersDlg(CWnd* pParent /*=NULL*/)
	: CPropDlg(CKnownServersDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKnownServersDlg)
	m_WorkingOnly = FALSE;
	m_strWorkingServers = _T("");
	m_strTotalUsers = _T("");
	m_strTotalFiles = _T("");
	//}}AFX_DATA_INIT
}


void CKnownServersDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKnownServersDlg)
	DDX_Control(pDX, IDC_WAITMSG, m_Wait);
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	DDX_Control(pDX, IDC_TITEL, m_Titel);
	DDX_Check(pDX, IDC_ONLY, m_WorkingOnly);
	DDX_Text(pDX, IDC_ED_WORKING, m_strWorkingServers);
	DDX_Text(pDX, IDC_ED_USERS, m_strTotalUsers);
	DDX_Text(pDX, IDC_ED_FILES, m_strTotalFiles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKnownServersDlg, CPropDlg)
	//{{AFX_MSG_MAP(CKnownServersDlg)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LISTE, OnColumnclickListe)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DONKEY, OnDonkey)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CKnownServersDlg 
BOOL CKnownServersDlg::OnInitDialog() 
{
	CPropDlg::OnInitDialog();

	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TITEL);
	
	// Listenspalten anlegen
	m_Liste.InsertColumn(0,"Num", LVCFMT_CENTER, 40);
	m_Liste.InsertColumn(1,"Name", LVCFMT_LEFT, 140);
	m_Liste.InsertColumn(2,"IP", LVCFMT_LEFT, 100);
	m_Liste.InsertColumn(3,"Port", LVCFMT_RIGHT, 50);
//	m_Liste.InsertColumn(4,"Ping", LVCFMT_CENTER, 50);	
	m_Liste.InsertColumn(4,"Users", LVCFMT_RIGHT, 90);	
	m_Liste.InsertColumn(5,"Files", LVCFMT_RIGHT, 60);	

	return TRUE;  
}


void CKnownServersDlg::Load()
{
	m_Refresh.EnableWindow(TRUE);
	m_Wait.ShowWindow(SW_HIDE);
	m_Liste.EnableWindow(TRUE);
}

void CKnownServersDlg::Save()
{
}

// OnRefresh
// Klick auf "Refresh" : Aktualisieren der Anzeige
void CKnownServersDlg::OnRefresh() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	m_Liste.DeleteAllItems();
	
	if (cmd->IsChildRunning())
	{		
		m_Refresh.EnableWindow(FALSE);
		m_Liste.EnableWindow(FALSE);
		m_Wait.ShowWindow(SW_SHOW);

		UpdateData();

		if (m_WorkingOnly)
		{
			cmd->Execute("vs working\n",this->m_hWnd);
		}
		else
		{
			cmd->Execute("vs\n",this->m_hWnd);
		}
	}
}

// OnDonkey
// Message from Server : Kommando ausgefhrt
// Parsen des Rckgabewertes und flllen der User-Liste
LRESULT	CKnownServersDlg::OnDonkey(LPARAM lParam, WPARAM wParam)
{
	CString* s = (CString*)lParam;
	int pos = s->Find("[");
	CString line;
	
	CString str = s->Mid(pos);
	pos = str.Find("\n");
	str = str.Mid(pos + 1);

	UINT	len = str.GetLength();

	CTokenEx token;
	CStringArray array;

	UpdateData();
	
	int count = 0;

	m_Wait.ShowWindow(SW_HIDE);
	m_Liste.EnableWindow(TRUE);
		
//	if (m_WorkingOnly) str = str.Mid(str.Find("Working:") + 10);
//	else str = str.Left(str.Find("Working:"));
		

	while ((pos = str.Find("\n")) != -1)
	{
		array.RemoveAll();
		line = str.Left(pos);
		line.Remove('[');
		line.Remove(']');
		line.Remove('(');
		line.Remove(')');
		str = str.Mid(pos + 1);

//		token.Split(line, "\t",array);
		token.Split(line, " ",array);

		if ((pos = line.Find("working servers")) == -1)
		{
			if (array.GetSize() >= 8)
			{
				TRACE("0: '%s'\n", array[0]);
				TRACE("1: '%s'\n", array[1]);
				TRACE("2: '%s'\n", array[2]);
				TRACE("3: '%s'\n", array[3]);	// users / max users
				TRACE("4: '%s'\n", array[4]);	// files
				TRACE("5: '%s'\n", array[5]);
				TRACE("6: '%s'\n", array[6]);
				TRACE("7: '%s'\n", array[7]);
				int item = m_Liste.InsertItem(count++, array[0]);

				CString IP = array[1].SpanExcluding(":");
				CString Port = array[1].Mid(array[1].Find(":") + 1);
				if (array.GetSize() > 8)
				{
					// server name
					if (array[7].GetLength() > 3)
					{
						m_Liste.SetItemText(item, 1, array[7]);
					}
					else
					{
						m_Liste.SetItemText(item, 1, IP);
					}
				}
				// IP
				m_Liste.SetItemText(item, 2, IP);
				// Port
				m_Liste.SetItemText(item, 3, Port);
	/*
				// Ping
				CString ping;
				ping.Format("%d", array[7])
				m_Liste.SetItemText(item, 4, );
	*/
				// Users
				m_Liste.SetItemText(item, 4, array[2]);
				// Files
				m_Liste.SetItemText(item, 5, array[3]);
					
			}
		}
		else
		{
			if (!m_WorkingOnly)
			{
				m_strTotalUsers = array[2];
				m_strTotalFiles = array[4];
				m_strWorkingServers = array[6];
			}
		}
	} ;

	UpdateData(false);

	m_Refresh.EnableWindow(TRUE);
	
	return 0;
}

// CompareItems
// Callbackfunktion der Listensortierung.
// Vergleicht zwei Elemente anhalnd der Spaltennummer miteinander
int CALLBACK CKnownServersDlg::CompareItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORT_PARMS* sp = (SORT_PARMS*)lParamSort;
	CListCtrl* plist = (CListCtrl*)CWnd::FromHandle(sp->hwnd);

	CString item1, item2;
	item1 = plist->GetItemText(lParam1,sp->nCol);
	item2 = plist->GetItemText(lParam2,sp->nCol);

	switch (sp->nCol)
	{
	case 0:	// Nummer
		{
			item1.Delete(0);					// Linke Klammer entfernen
			item2.Delete(0);
			item1.Delete(item1.GetLength() - 1);// Rechte Klammer entfernen
			item2.Delete(item2.GetLength() - 1);

			return (atoi(item1) - atoi(item2));
		}
	case 1:	// Name
		{
			return item1.CompareNoCase(item2);
		}
	case 2:	// IP
		{
			long ip1 = inet_addr(item1);
			long ip2 = inet_addr(item2);

			if ((ip1 & 0x000000FF) < (ip2 & 0x000000FF)) return -1;
			if ((ip1 & 0x000000FF) > (ip2 & 0x000000FF)) return  1;

			if ((ip1 & 0x0000FF00) < (ip2 & 0x0000FF00)) return -1;
			if ((ip1 & 0x0000FF00) > (ip2 & 0x0000FF00)) return  1;

			if ((ip1 & 0x00FF0000) < (ip2 & 0x00FF0000)) return -1;
			if ((ip1 & 0x00FF0000) > (ip2 & 0x00FF0000)) return  1;

			if ((ip1 & 0xFF000000) < (ip2 & 0xFF000000)) return -1;
			if ((ip1 & 0xFF000000) > (ip2 & 0xFF000000)) return  1;
						
			return 0;
		}	
	case 3:
	case 4:
			return (atoi(item1) - atoi(item2));
	}

	return 0;
}

// OnColumnclickListe
// Klick auf Listenheader : Sortierung starten
void CKnownServersDlg::OnColumnclickListe(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* plv = (NM_LISTVIEW*)pNMHDR;

	SORT_PARMS sparms;
	sparms.nCol = plv->iSubItem;
	sparms.hwnd = m_Liste.GetSafeHwnd();
        
	int nCount = m_Liste.GetItemCount(), lp = 0;
	for (lp=0; lp<nCount; lp++) m_Liste.SetItemData(lp,lp);

	m_Liste.SortItems((PFNLVCOMPARE)CompareItems, (DWORD)&sparms);

	*pResult = 0;

}
