// Language.cpp: Implementierung der Klasse CLanguage.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "Language.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CLanguage::CLanguage()
{
}

CLanguage::~CLanguage()
{

}

bool CLanguage::Init()
{
	// Sprachen-DLL laden	
	hDLL = LoadLibrary("LangDLL.dll");
	if (hDLL != NULL)
	{			
		// Filter aufrufen
		lpStringProc = (LPSTRINGPROC)GetProcAddress(hDLL,"GetLangString");	

		if (lpStringProc != NULL) return true;
		else FreeLibrary(hDLL); 		
	}

	return false;
}

CString	CLanguage::GetStr(UINT nID)
{
	if (lpStringProc) return lpStringProc(nID);

	return "";
}

void CLanguage::SetText(CWnd* pCtrl)
{
	// alten Fenstertitel bestimmen
	CString altTitel, neuTitel;
	pCtrl->GetWindowText(altTitel);

	// Nummer extrahieren
	int start, ende;
	CString nummer;
	if ((start = altTitel.Find("#")) != -1) 
	{
		nummer = altTitel.Mid(start + 1);
		neuTitel = GetStr(atoi(nummer));
		
		altTitel.Delete(start, nummer.GetLength() + 1);
		
		if (!neuTitel.IsEmpty()) pCtrl->SetWindowText(neuTitel);						
		else pCtrl->SetWindowText(altTitel);						
	}			
}

void CLanguage::Localisation(CWnd* pWnd, int nDlgItemId)
{
	CWnd	*pCtrlWnd;

	if (pWnd == NULL || (pCtrlWnd = pWnd->GetDlgItem(nDlgItemId)) == NULL)
		return;

	do
	{
		SetText(pCtrlWnd);		
	} while ((pCtrlWnd = GetNextDlgGroupItemEx(pCtrlWnd)) != NULL);
}

CWnd* CLanguage::GetNextDlgGroupItemEx(CWnd *pCtrlWnd)
{
	CWnd	*pWnd;

	if (pCtrlWnd == NULL
	|| pCtrlWnd->GetDlgCtrlID() == 0
	|| (pWnd = pCtrlWnd->GetWindow(GW_HWNDNEXT)) == NULL)
//	|| (pWnd->GetStyle() & WS_GROUP))
	{
		return NULL;
	}

	return pWnd;
}