// SeedServerDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Donkey.h"
#include "SeedServerDlg.h"
#include "winsock2.h"
#include "Serverlist/Serverlist.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSeedServerDlg 


CSeedServerDlg::CSeedServerDlg(CWnd* pParent /*=NULL*/)
	: CResizingDialog(CSeedServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSeedServerDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
	ip = "";
	port = 0;
}


void CSeedServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSeedServerDlg)
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSeedServerDlg, CResizingDialog)
	//{{AFX_MSG_MAP(CSeedServerDlg)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LISTE, OnColumnclickListe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSeedServerDlg 

BOOL CSeedServerDlg::OnInitDialog() 
{
	CResizingDialog::OnInitDialog();

	// Lokalisierung setzen
	Lang.Localisation(this,IDOK);
	this->SetWindowText(Lang.GetStr(39));

	// ResizeDlg: Controls festsetzen
	SetControlInfo(IDC_LISTE, RESIZE_HOR | RESIZE_VER);
	SetControlInfo(IDOK, ANCHORE_RIGHT | ANCHORE_BOTTOM);
	SetControlInfo(IDCANCEL, ANCHORE_RIGHT | ANCHORE_BOTTOM);

	// Listenattribute setzen
	m_Liste.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// Listenspalten 
	m_Liste.InsertColumn(0,"IP",LVCFMT_LEFT,100);
	m_Liste.InsertColumn(1,"Port",LVCFMT_LEFT,50);
	m_Liste.InsertColumn(2,"Name",LVCFMT_LEFT,200);
	m_Liste.InsertColumn(3,"Description",LVCFMT_LEFT,200);

	// Liste fllen
	Refresh();
	
	return TRUE;
}

// Refresh
// Fllen der Listen mit allen verfgbaren Seed-Servern
bool CSeedServerDlg::Refresh()
{
	// Liste leeren
	m_Liste.DeleteAllItems();

	CServerlist Serverlist;
	int count = 0;

	if (Serverlist.OpenServerlistFile("serverlist.txt"))
	{
		CString IP, Port, Name, Desc;
		while (Serverlist.GetNextEntry(IP, Port, Name, Desc))
		{
			int item = m_Liste.InsertItem(count++, IP);
			m_Liste.SetItemText(item,1,Port);
			m_Liste.SetItemText(item,2,Name);
			m_Liste.SetItemText(item,3,Desc);
		}
	}

	if (m_Liste.GetItemCount() == 0) 
		AfxMessageBox("There couldn't be found any servers.\nDownload a new list or go to http://edonkey.iucon.com to get a new serverlist.dll!");

	return true;
}

// GetServer
// Gibt die Informationen ber den ausgewhlten Seed-Server zurck
// out : 
// - ip : IP des Servers
// - port : Port des Servers
void CSeedServerDlg::GetServer(CString& ip, UINT& port)
{
	ip = this->ip;
	port = this->port;
}

void CSeedServerDlg::OnOK() 
{
	// Ist ein Server ausgewhlt?
	if (m_Liste.GetSelectedCount() == 1)
	{
		POSITION pos = m_Liste.GetFirstSelectedItemPosition();

		if (pos)
		{
			int item = m_Liste.GetNextSelectedItem(pos);
			ip = m_Liste.GetItemText(item,0);
			port = atoi(m_Liste.GetItemText(item,1));

			CResizingDialog::OnOK();
		}
	}
	else AfxMessageBox("Please select a server first!",MB_OK | MB_ICONINFORMATION);	
}

// CompareItems
// Callbackfunktion der Listensortierung.
// Vergleicht zwei Elemente anhalnd der Spaltennummer miteinander
int CALLBACK CSeedServerDlg::CompareItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORT_PARMS* sp = (SORT_PARMS*)lParamSort;
	CListCtrl* plist = (CListCtrl*)CWnd::FromHandle(sp->hwnd);

	CString item1, item2;
	item1 = plist->GetItemText(lParam1,sp->nCol);
	item2 = plist->GetItemText(lParam2,sp->nCol);

	switch (sp->nCol)
	{
	case 0:	// IP
		{
			long ip1 = inet_addr(item1);
			long ip2 = inet_addr(item2);

			if ((ip1 & 0x000000FF) < (ip2 & 0x000000FF)) return -1;
			if ((ip1 & 0x000000FF) > (ip2 & 0x000000FF)) return  1;

			if ((ip1 & 0x0000FF00) < (ip2 & 0x0000FF00)) return -1;
			if ((ip1 & 0x0000FF00) > (ip2 & 0x0000FF00)) return  1;

			if ((ip1 & 0x00FF0000) < (ip2 & 0x00FF0000)) return -1;
			if ((ip1 & 0x00FF0000) > (ip2 & 0x00FF0000)) return  1;

			if ((ip1 & 0xFF000000) < (ip2 & 0xFF000000)) return -1;
			if ((ip1 & 0xFF000000) > (ip2 & 0xFF000000)) return  1;
						
			return 0;
		}
	case 1: // Port
	case 2:	// Username
	case 3: // Beschreibung
		{
			return item1.CompareNoCase(item2);
		}
	}

	return 0;
}

void CSeedServerDlg::OnColumnclickListe(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* plv = (NM_LISTVIEW*)pNMHDR;

	SORT_PARMS sparms;
	sparms.nCol = plv->iSubItem;
	sparms.hwnd = m_Liste.GetSafeHwnd();
        
	int nCount = m_Liste.GetItemCount(), lp = 0;
	for (lp=0; lp<nCount; lp++) m_Liste.SetItemData(lp,lp);

	m_Liste.SortItems((PFNLVCOMPARE)CompareItems, (DWORD)&sparms);

	*pResult = 0;
}
