// ServerDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "winsock2.h"
#include "Donkey.h"
#include "ServerDlg.h"
#include "DonkeyDlg.h"
#include "IniFile.h"
#include "IPEnum.h"
#include "TokenEx.h"
#include "Iphlpapi.h"
// #include "winsock2.h"
#include "HttpDownloadDlg.h"
#include "SeedServerDlg.h"
#include "StopServerDlg.h"
#include "DialupDlg.h"
#include "Wininet.h"
#include "Serverlist/Serverlist.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Zeit bis zum WM_TIMER-Event
int CServerDlg::TIMERVALUE = 15000;

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CServerDlg 

CServerDlg::CServerDlg(CWnd* pParent /*=NULL*/)
	: CPropDlg(CServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerDlg)
	m_Beschreibung = _T("");
	m_LocalPort		= 4661;
	m_MaxClients	= 200;
	m_Message		= _T("");
	m_Name			= _T("");
	m_Public		= TRUE;
	m_SeedIP		= _T("");
	m_SeedPort		= 0;
	m_Stay			= FALSE;
	//}}AFX_DATA_INIT

	WelcomeString.LoadString(IDS_WELCOME_MESSAGE);
}


void CServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerDlg)
	DDX_Control(pDX, IDC_DIAL, m_DialUp);
	DDX_Control(pDX, IDC_DETECT, m_Detect);
	DDX_Control(pDX, IDC_STOP, m_Stop);
	DDX_Control(pDX, IDC_START, m_Start);
	DDX_Control(pDX, IDC_LOCALIP, m_LocalIP);
	DDX_Control(pDX, IDC_TITEL, m_Titel);
	DDX_Text(pDX, IDC_BESCHREIBUNG, m_Beschreibung);
	DDX_Text(pDX, IDC_LOCALPORT, m_LocalPort);
	DDX_Text(pDX, IDC_MAXCLIENTS, m_MaxClients);
	DDX_Text(pDX, IDC_MESSAGE, m_Message);
	DDX_Text(pDX, IDC_NAME, m_Name);
	DDX_Check(pDX, IDC_PUBLIC, m_Public);
	DDX_Text(pDX, IDC_SEEDIP, m_SeedIP);
	DDX_Text(pDX, IDC_SEEDPORT, m_SeedPort);
	DDX_Check(pDX, IDC_STAY, m_Stay);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServerDlg, CPropDlg)
	//{{AFX_MSG_MAP(CServerDlg)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_DETECT, OnDetect)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_STAY, OnStay)
	ON_BN_CLICKED(IDC_DIAL, OnDial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CServerDlg 

BOOL CServerDlg::OnInitDialog() 
{
	CPropDlg::OnInitDialog();

	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TITEL);

	// Tooltips setzen
//	m_Detect.SetToolTipText("Detect your public IP automatically");
	
	CIPEnum ipenum;
	ipenum.Enumerate();

	for (int i = 0; i < ipenum.ips.GetSize(); i++)
		m_LocalIP.AddString(ipenum.ips[i]);

	m_Stop.EnableWindow(FALSE);
	
	return TRUE; 
}

// Load
// Laden der Einstellungen
void CServerDlg::Load()
{
	CIniFile ini;
	ini.SetPath("donkey.ini");

	if (ini.ReadFile())
	{
		m_Name = ini.GetValue("server","name","Your server");
		m_Beschreibung = ini.GetValue("server","desc","a server");
		m_Public = (ini.GetValue("server","public","true") == "true") ? TRUE : FALSE;
		m_LocalPort = ini.GetValueI("server","port","4661");
		m_SeedIP = ini.GetValue("server","seedIP","");
		m_SeedPort = ini.GetValueI("server","seedPort","4661");
		m_MaxClients = ini.GetValueI("server","maxClients","200");

		CString localIP = ini.GetValue("server","thisIP","");
		m_LocalIP.SetWindowText(localIP);

		// Welcome Message einlesen
		m_Message = "";
		int count = 0;
		CString strCount; strCount.Format("welcome[%i]",count++);

		while (ini.FindValue(ini.FindKey("server"),strCount) > -1)
		{
//			if (count > 1 || ini.GetValue("server",strCount,"").Find("edonkey.iucon.com") == -1)			
//			{
				m_Message+= ini.GetValue("server",strCount,"");
				m_Message+= "\r\n";
//			}

			strCount.Format("welcome[%i]",count++);
		}

		m_Stay = ini.GetValueI("Control","stay","0");
	
		UpdateData(FALSE);

		OnStay();
	}
}

// Save
// Speichern der Einstellungen
void CServerDlg::Save()
{
	CIniFile ini;
	ini.SetPath("donkey.ini");
	ini.ReadFile();

	UpdateData();

	CString localIP; m_LocalIP.GetWindowText(localIP);
	
	// Debugging-Informationen schreiben lassen
	ini.SetValue("server","verbose","false");

	// Benutzerdefinierte Einstellungen
	ini.SetValue("server","name",m_Name);
	ini.SetValue("server","desc",m_Beschreibung );
	ini.SetValue("server","public",(m_Public) ? "true" : "false");
	ini.SetValue("server","thisIP",localIP);
	ini.SetValueI("server","port",m_LocalPort);
	if (!m_SeedIP.IsEmpty())
	{
		ini.SetValue("server","seedIP",m_SeedIP);
		ini.SetValueI("server","seedPort",m_SeedPort);
	}
	else
	{
		ini.DeleteValue("server","seedIP");
		ini.DeleteValue("server","seedPort");
	}
	ini.SetValueI("server","maxClients",m_MaxClients);

	ini.SetValue("server", "filter[0]", "(.part.met)"); 
	ini.SetValue("server", "filter[1]", "(.part.stats)"); 
	ini.SetValue("server", "filter[2]", "(#FORMAT met)"); 
	ini.SetValue("server", "filter[3]", "(#FORMAT part)"); 
	ini.SetValue("server", "filter[4]", "(#FORMAT dll)|(#FORMAT sys)");
	
	// alle Message-Zeilen lschen
	CString line;
	int i = 0;
	line.Format("welcome[%i]",i);
	while (ini.FindValue(ini.FindKey("server"),line) != -1) 
	{
		ini.DeleteValue("server",line);
		line.Format("welcome[%i]",++i);
	}

	// Message-Zeilen neu anlegen
	CStringArray lines;	
	CTokenEx token;
	m_Message.Remove('\r');
	token.Split(m_Message,"\n",lines);

	ini.SetValue("server","welcome[0]",WelcomeString);
	for (i = 0; i < lines.GetSize(); i++)
	{
		line.Format("welcome[%i]", i);
		ini.SetValue("server",line,lines[i]);
	}
	
	ini.SetValueI("Control","stay",m_Stay);

	ini.WriteFile();
}

// OnStart
// Klick auf den Button "Start"
void CServerDlg::OnStart() 
{
	Save();

	StartServer();
}

// StartServer
// Startet den Server
void CServerDlg::StartServer()
{
	// logfile lschen
	CIniFile ini("donkey.ini");
	if (ini.ReadFile())
	{
		if (ini.GetValue("Control","clear","false") == "true")
			DeleteFile("log");
	}

	CDonkeyApp* pApp = (CDonkeyApp*)AfxGetApp();

	// Prfen, ob Server im gleichen Verzeichnis liegt
	CFileFind finder;
	if (finder.FindFile(pApp->m_ServerExe))
	{
		((CDonkeyDlg*)GetParent())->m_Donkey.Start();
		
		m_Start.EnableWindow(FALSE);
		m_Stop.EnableWindow(TRUE);
		
		if (m_Stay) SetTimer(WM_TIMER,TIMERVALUE,&TimerProc);
	}
	else AfxMessageBox("eserver must be in the same directory!\nDonkey Controll will exit now",MB_OK | MB_ICONEXCLAMATION);
}

void CServerDlg::StopServer()
{
	((CDonkeyDlg*)GetParent())->m_Donkey.Stop();	
}

// OnStop
// Klick auf "Stop" : Stoppen des Servers
void CServerDlg::OnStop() 
{
	StopServer();

	m_Start.EnableWindow(TRUE);
	m_Stop.EnableWindow(FALSE);	

	KillTimer(WM_TIMER);
}

// OnDetect
// Klick auf "Detect" : Bestimmen der Public IP
void CServerDlg::OnDetect() 
{
	CString ip = GetPublicIP();

	if (ip != "Error")
		m_LocalIP.SetWindowText(ip);		
	else
		AfxMessageBox("No public IP detected!",MB_OK | MB_ICONEXCLAMATION);
}

// GetPublicIP
// Bestimmt die public IP
// out :
// - CString : IP, falls verfgbar, sonst "Error"
CString CServerDlg::GetPublicIP()
{
/*	DWORD BestInterface;
	CString ip;
	if (GetBestInterface(inet_addr("212.227.118.195"),&BestInterface) != NO_ERROR)
	{		
		return "Error";
	}

	DWORD dwSize = sizeof(DWORD) + sizeof(MIB_IPADDRROW) * 10;
	PMIB_IPADDRTABLE pIpAddrTable = (PMIB_IPADDRTABLE) new BYTE [dwSize]; 

	// Alle IPs nach dem besten Interface durchsuchen
	if (GetIpAddrTable ((PMIB_IPADDRTABLE) pIpAddrTable,&dwSize, FALSE) == NO_ERROR)
	{
		for (int i = 0; i < (int) pIpAddrTable->dwNumEntries; i ++)
		{
			if (pIpAddrTable->table[i].dwIndex == BestInterface)
			{
				in_addr ina;
				ina.S_un.S_addr = pIpAddrTable->table[i].dwAddr;
				
				// IP gefunden
				ip = inet_ntoa(ina);				
			}
		}
	}

	delete [] pIpAddrTable;		*/
	
	MIB_IPFORWARDROW iprow;
	CString ip = "Error";

	if (GetBestRoute(inet_addr("212.227.118.195"),NULL,&iprow) == NO_ERROR)
	{		
		bool localIP = false;

		ip.Format("%i.%i.%i.%i",iprow.dwForwardNextHop & 0x000000FF,
								(iprow.dwForwardNextHop & 0x0000FF00) >> 8,
								(iprow.dwForwardNextHop & 0x00FF0000) >> 16,
								(iprow.dwForwardNextHop & 0xFF000000) >> 24);

		// Test auf Router
		DWORD dwSize = sizeof(DWORD) + sizeof(MIB_IPADDRROW) * 100;
		PMIB_IPADDRTABLE pIpAddrTable = (PMIB_IPADDRTABLE) new BYTE [dwSize]; 
		
		// Alle IPs nach dem Interface durchsuchen
		if (GetIpAddrTable ((PMIB_IPADDRTABLE) pIpAddrTable,&dwSize, FALSE) == NO_ERROR)
		{
			for (int i = 0; i < (int) pIpAddrTable->dwNumEntries; i ++)
			{				
				if (pIpAddrTable->table[i].dwAddr == iprow.dwForwardNextHop)
				{
					// lokale IP gefunden
					localIP = true;

					// Timerlnge setzen auf 15 sek
					TIMERVALUE = 15000;
					
					break;
				}
			}
		}
		
		delete [] pIpAddrTable;		

		// Verbindung durch Router
		if (!localIP)
		{
			AfxGetMainWnd()->BeginWaitCursor();
			
			HINTERNET handle = InternetOpen("DC",INTERNET_OPEN_TYPE_PRECONFIG,NULL,NULL,0);

			HINTERNET fileHandle = InternetOpenUrl(handle,"http://edonkey.iucon.com/detectip.php",NULL,0,INTERNET_FLAG_PRAGMA_NOCACHE,0);

			if (fileHandle)
			{
				char szSizeBuffer[1024];
				DWORD dwLengthSizeBuffer = 1024;
				DWORD dwFileSize;
				DWORD dwBytesRead;
				CString Contents, sContents;

				// Getting the size of HTTP Files
				BOOL bQuery =   ::HttpQueryInfo(fileHandle,HTTP_QUERY_CONTENT_LENGTH, szSizeBuffer, &dwLengthSizeBuffer, NULL) ;
				LPSTR pszContents = NULL; 
				
				if (bQuery==TRUE)
				{    
					// Allocating the memory space for HTTP file contents
					dwFileSize = atol(szSizeBuffer);
					pszContents = Contents.GetBuffer(dwFileSize);
				}
				else 
				{
					dwFileSize = 0x10000;	// Max size
					pszContents = sContents.GetBuffer(dwFileSize);
				}
				
				// Read the HTTP file 
				BOOL bRead;
				DWORD dwPos = 0;
				do 
				{
					Sleep(0);
					bRead = ::InternetReadFile(fileHandle, pszContents+dwPos, dwFileSize-dwPos, &dwBytesRead); 
					dwPos += dwBytesRead;
				} while (bRead && dwBytesRead>0);
								
				sContents.ReleaseBuffer(dwPos);
				ip = sContents;

			} else AfxMessageBox("Unable to reach the host http://edonkey.iucon.com");

			InternetCloseHandle(handle);

			// Timerlnge setzen auf 5 min
			TIMERVALUE = 300000;	

			AfxGetMainWnd()->EndWaitCursor();
		}
	}
	
	return ip;
}

// OnSelect
// Klick auf "Select" : ffnen des Seed-Server-Dialogs
void CServerDlg::OnSelect() 
{
	CServerlist serverlist;	
	CHttpDownloadDlg dlg;
    dlg.m_sURLToDownload = serverlist.GetURL();
    dlg.m_sFileToDownloadInto = "Serverlist.txt";
	
	dlg.DoModal();
	
	CSeedServerDlg seedDlg;
	if (seedDlg.DoModal() == IDOK)
	{
		UpdateData();
		seedDlg.GetServer(m_SeedIP, m_SeedPort);
		UpdateData(FALSE);
	}
}

// OnExit
// Klick auf "Exit" : Beenden des Programms
void CServerDlg::OnExit() 
{
	KillTimer(WM_TIMER);

	Save();

	((CDonkeyDlg*)GetParent())->OnCancel();		
}

// OnStay
// Klick auf "Stay connected"
void CServerDlg::OnStay() 
{
	UpdateData();

	m_LocalIP.EnableWindow(!m_Stay);
	m_Detect.EnableWindow(!m_Stay);
	m_DialUp.EnableWindow(m_Stay);
	
	if (m_Stay) OnDetect();
}

// OnDial
// Klick auf "Dial up" : ffnen der Einwahleinstellungen
void CServerDlg::OnDial() 
{
	CDialupDlg dlg;
	dlg.DoModal();
}

// TimerProc
// berprft, ob eine Internetverbindung noch besteht oder ob sich
// die Public IP gendert hat. In diesem Fall wird der Server neu gestartet.
void CALLBACK EXPORT CServerDlg::TimerProc(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime)
{
	CServerDlg* pDlg = (CServerDlg*)CWnd::FromHandle(hWnd);
	
	// Timer killen
	pDlg->KillTimer(WM_TIMER);

	CString ip = pDlg->GetPublicIP();
	CString localIP;
	pDlg->m_LocalIP.GetWindowText(localIP);

	// Neue Verbindung aufbauen
	if (ip == "Error")
	{
		// Telefonbucheintrag lesen
		CIniFile ini("donkey.ini");
		ini.ReadFile();
		ini.SetValue("server","thisIP",ip);

		CString entry = ini.GetValue("Control","entry","");
		if (!entry.IsEmpty() && entry != "No automatic redial")
		{
			char strEntry[256];
			strcpy(strEntry,entry);

			DWORD conID;
			DWORD ret = InternetDial(pDlg->m_hWnd,strEntry,INTERNET_DIAL_UNATTENDED,&conID,0);
			if (ret != ERROR_SUCCESS)
			{
				switch (ret)
				{
				case ERROR_INVALID_PARAMETER:
					AfxMessageBox("Dial up error: One or more of the parameters are incorrect");
					break;
				default:
					AfxMessageBox("Dial up error: Undefined error or user abort");
					break;
				}
			}
		}

		ip = pDlg->GetPublicIP();
	}

	// Server neustarten
	if (ip != localIP)
	{
		pDlg->StopServer();
		
		if (ip != "Error")
		{
			pDlg->m_LocalIP.SetWindowText(ip);		

			// neue IP in ini-Datei schreiben
			CIniFile ini("donkey.ini");
			ini.ReadFile();
			ini.SetValue("server","thisIP",ip);
			ini.WriteFile();

			// Server neu starten
			pDlg->StartServer();			

			// Timer ist schon neu gestartet durch StartServer()
			// oder wird nicht bentigt
			return;
		}		
	} 
	
	// Timer neu starten
	pDlg->SetTimer(WM_TIMER,TIMERVALUE,&TimerProc);
}
