// StatsDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "donkey.h"
#include "StatsDlg.h"
#include "DonkeyCmd.h"
#include "DonkeyDlg.h"
#include "TokenEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CStatsDlg 


CStatsDlg::CStatsDlg(CWnd* pParent /*=NULL*/)
	: CPropDlg(CStatsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatsDlg)
	m_Files = _T("");
	m_Clients = _T("");
	m_Uptime = _T("");
	m_eMule = _T("");
	m_mlDonkey = _T("");
	m_zLib = _T("");
	m_Servers = _T("");
	m_WServers = _T("");
	//}}AFX_DATA_INIT
}


void CStatsDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatsDlg)
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	DDX_Control(pDX, IDC_TITEL, m_Titel);
	DDX_Text(pDX, IDC_FILES, m_Files);
	DDX_Text(pDX, IDC_CLIENTS, m_Clients);
	DDX_Text(pDX, IDC_UPTIME, m_Uptime);
	DDX_Text(pDX, IDC_ED_EMULE, m_eMule);
	DDX_Text(pDX, IDC_ED_MLDK, m_mlDonkey);
	DDX_Text(pDX, IDC_ED_ZLIB, m_zLib);
	DDX_Text(pDX, IDC_ED_SERVERS, m_Servers);
	DDX_Text(pDX, IDC_ED_WSERVERS, m_WServers);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatsDlg, CPropDlg)
	//{{AFX_MSG_MAP(CStatsDlg)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DONKEY, OnDonkey)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CStatsDlg 

BOOL CStatsDlg::OnInitDialog() 
{
	CPropDlg::OnInitDialog();
	
	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TITEL);

	return TRUE; 
}

// Laden der Einstellungen
void CStatsDlg::Load()
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	// Uptime feststellen
	if (cmd->IsChildRunning())
	{
		UpdateTime();
		
		// Timer starten
		SetTimer(WM_TIMER + 1, 10000, &TimerProc);
	} else m_Uptime = Lang.GetStr(36);

	UpdateData(FALSE);
}

void CStatsDlg::Save()
{
	KillTimer(WM_TIMER + 1);
}

// OnRefresh
// Klick auf "Refresh" : Aktualisieren der Informationen
void CStatsDlg::OnRefresh() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	m_Clients.Empty();
	m_Files.Empty();
	UpdateData(FALSE);

	if (cmd->IsChildRunning())
	{
		m_Refresh.EnableWindow(FALSE);
		
		cmd->Execute("g",this->m_hWnd);	
	}
}

// UpdateTime
// Aktuelisieren der uptime
void CStatsDlg::UpdateTime()
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	// Uptime feststellen
	if (cmd->IsChildRunning())
	{
		time_t curTime; time(&curTime);
		CTimeSpan span(curTime - cmd->GetStartupTime());
		m_Uptime = span.Format("%Dd, %Hh, %Mm");
	} else m_Uptime = Lang.GetStr(36);
	
	UpdateData(FALSE);
}

// OnDonkey
// Message vom Server : "Kommando ausgefhrt"
// Lesen der Serverausgabe und Aktualisierung der Anzeige
LRESULT	CStatsDlg::OnDonkey(LPARAM lParam, WPARAM wParam)
{
	CString* s = (CString*)lParam;
	CString str = s->Mid(0);
	CString line;
	int pos;

	int LineCount = 0;

//	str.Remove('\x0A');
//	str.Remove('\x0D');
//	str = str.Mid(str.Find("commands") + 10);

	CTokenEx token;
	CStringArray array;

	while ((pos = str.Find("\n")) != -1)
	{
		array.RemoveAll();
		line = str.Left(pos);
		str = str.Mid(pos + 1);
		line.Remove('(');
		line.Remove(')');
		token.Split(line," ",array);

		if (line.Find("zlib") != -1)
		{
			if (array.GetSize() > 7)
			{
				TRACE("0: '%s'\n", array[0]);
				TRACE("1: '%s'\n", array[1]);
				TRACE("2: '%s'\n", array[2]);
				TRACE("3: '%s'\n", array[3]);	// users / max users
				TRACE("4: '%s'\n", array[4]);	// files
				TRACE("5: '%s'\n", array[5]);
				TRACE("6: '%s'\n", array[6]);
				TRACE("7: '%s'\n", array[7]);
				m_Clients	= array[0];
				m_eMule		= array[4];
				m_zLib		= array[2];
				m_mlDonkey	= array[6];
			}
		}

		if (line.Find("keyw") != -1)
		{
			if (array.GetSize() >= 1)
			{
				TRACE("0: '%s'\n", array[0]);
				TRACE("1: '%s'\n", array[1]);
				TRACE("2: '%s'\n", array[2]);
				TRACE("3: '%s'\n", array[3]);	// users / max users
				TRACE("4: '%s'\n", array[4]);	// files
				TRACE("5: '%s'\n", array[5]);
				TRACE("6: '%s'\n", array[6]);
				m_Files = array[0];
			}
		}

		if (line.Find("wservers") != -1)
		{
			if (array.GetSize() >= 1)
			{
				TRACE("0: '%s'\n", array[0]);
				TRACE("1: '%s'\n", array[1]);
				TRACE("2: '%s'\n", array[2]);
				TRACE("3: '%s'\n", array[3]);	// users / max users
				TRACE("4: '%s'\n", array[4]);	// files
				TRACE("5: '%s'\n", array[5]);
				TRACE("6: '%s'\n", array[6]);
				m_WServers = array[0];
				m_Servers  = array[3];
			}
		}
		LineCount++;
	}


	UpdateData(FALSE);

	m_Refresh.EnableWindow(TRUE);

	TRACE("CStatsDlg::OnDonkey done\n");

	return 0;
}

static timerCount = 0;

void CALLBACK EXPORT CStatsDlg::TimerProc(HWND hWnd, UINT nMsg, UINT nIDEvent, DWORD dwTime)
{
	CStatsDlg* pDlg = (CStatsDlg*)CWnd::FromHandle(hWnd);

	pDlg->UpdateTime();

	timerCount++;
	if (pDlg->IsWindowVisible() && (timerCount > 5))
	{
		timerCount = 0;
		pDlg->OnRefresh();
	}

}

