// UserDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Donkey.h"
#include "UserDlg.h"
#include "DonkeyDlg.h"
#include "DonkeyCmd.h"
#include "TokenEx.h"
#include "SendMessageDlg.h"
#include "winsock2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CUserDlg 


CUserDlg::CUserDlg(CWnd* pParent /*=NULL*/)
	: CPropDlg(CUserDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserDlg)
	m_bLimit = FALSE;
	m_nLimit = 0;
	m_bIpRange = FALSE;
	m_strIP_range = _T("");
	//}}AFX_DATA_INIT
}


void CUserDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserDlg)
	DDX_Control(pDX, IDC_WAITMSG, m_Wait);
	DDX_Control(pDX, IDC_REFRESH, m_Refresh);
	DDX_Control(pDX, IDC_LISTE, m_Liste);
	DDX_Control(pDX, IDC_TITEL, m_Titel);
	DDX_Check(pDX, IDC_CHK_LIMIT, m_bLimit);
	DDX_Text(pDX, IDC_ED_LIMIT, m_nLimit);
	DDV_MinMaxUInt(pDX, m_nLimit, 10, 10000);
	DDX_Check(pDX, IDC_CHK_IPRANGE, m_bIpRange);
	DDX_Text(pDX, IDC_ED_IPRANGE, m_strIP_range);
	DDV_MaxChars(pDX, m_strIP_range, 20);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUserDlg, CPropDlg)
	//{{AFX_MSG_MAP(CUserDlg)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_MESSAGE, OnMessage)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LISTE, OnColumnclickListe)
	ON_EN_KILLFOCUS(IDC_ED_LIMIT, OnKillfocusEdLimit)
	ON_EN_KILLFOCUS(IDC_ED_IPRANGE, OnKillfocusEdIprange)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_DONKEY, OnDonkey)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CUserDlg 

BOOL CUserDlg::OnInitDialog() 
{
	CPropDlg::OnInitDialog();

	// Lokalisierung setzen
	Lang.Localisation(this,IDC_TITEL);
	
	// Listenspalten anlegen
	m_Liste.InsertColumn(0,"Num", LVCFMT_RIGHT, 40);
	m_Liste.InsertColumn(1,"ID", LVCFMT_RIGHT, 80);
	m_Liste.InsertColumn(2,"Name", LVCFMT_LEFT, 150);
	m_Liste.InsertColumn(3,"Version", LVCFMT_LEFT, 50);
	m_Liste.InsertColumn(4,"Low", LVCFMT_LEFT, 40);
	m_Liste.InsertColumn(5,"Share", LVCFMT_RIGHT, 50);
	m_Liste.InsertColumn(6,"Searches", LVCFMT_RIGHT, 60);
	m_Liste.InsertColumn(7,"Flags", LVCFMT_LEFT, 50);

	m_strIP_range = "80.145.0.0/16";
	m_nLimit	  = 100;

	UpdateData(false);

	m_Liste.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	
	return TRUE;  
}


void CUserDlg::Load()
{
	m_Refresh.EnableWindow(TRUE);
	m_Wait.ShowWindow(SW_HIDE);
	m_Liste.EnableWindow(TRUE);
}

void CUserDlg::Save()
{
}

// OnRefresh
// Klick auf "Refresh" : Aktualisieren der Anzeige
void CUserDlg::OnRefresh() 
{
	CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;

	m_Liste.DeleteAllItems();

	if (cmd->IsChildRunning())
	{		
		m_Refresh.EnableWindow(FALSE);
		m_Liste.EnableWindow(FALSE);
		m_Wait.ShowWindow(SW_SHOW);

/*
		// workaround to fill the outbuffer
		for (int n=0; n < 20; n++)
		{
			cmd->Execute("?\n",this->m_hWnd);	
		}
*/
		CString cmdStr = "vc";

		if (m_bLimit)
		{
			cmdStr += " " +  m_nLimit;
		}

		if (m_bIpRange)
		{
			cmdStr += " " +  m_strIP_range;
		}

		cmd->Execute(cmdStr, this->m_hWnd);
	}
	else
	{
		AfxMessageBox("eServer is not running");
	}
}

// OnDonkey
// Message from Server : Kommando ausgefhrt
// Parsen des Rckgabewertes und flllen der User-Liste
LRESULT	CUserDlg::OnDonkey(LPARAM lParam, WPARAM wParam)
{
	CString* s = (CString*)lParam;
	CString str = s->Mid(0);

	int pos;
	CTokenEx token;
	CStringArray array;
	
	int		count = 0;
	bool	bLowId;

	m_Wait.ShowWindow(SW_HIDE);
	m_Liste.EnableWindow(TRUE);

/*
	str = "[ num]         ID             IP:port   [version rcv    xmt    share   sources   times  searches lowid flags]  nickname\n"
		+ CString("[  20] 1029741717   149.156.96.61:4662  [v:61/0 r:225.3 x:310.2.0 p:0  S:  0|  0/  0/  7 t:105/104/105 s:0 l:0/0 f:] prcdes [PL]\n")
		+ CString("[  40] 1477751212   172.177.20.88:4662  [v:61/0 r:2347.6 x:310.2.0 p:20 S:  0|  0/  0/  1 t:30/17/29 s:0 l:0/0 f:] ehipt\n")
		+ CString("[  52] 1680145601  193.252.36.100:4662  [v:61/0 r:198.3 x:310.2.0 p:0  S:  0|  0/  0/  6 t:14/12/13 s:0 l:0/0 f:EoM] mbqbvo\n")
		+ CString("[  44]         1*  203.70.196.208:4662  [v:61/0 r:18989.20 x:310.2.0 p:125 S:  0|  0/  0/  0 t:26/0/5 s:0 l:0/0 f:] pqoff\n")
		+ CString("[  56]         2*   212.87.229.28:4662  [v:61/0 r:176.4 x:310.2.0 p:0  S:  0|  0/  0/  5 t:4/0/3 s:0 l:0/0 f:E] hepcep\n");
*/
	
	while ((pos = str.Find("\n")) != -1)
	{

		CString line = str.Left(pos);
		str = str.Mid(pos + 1);

		bLowId = false;
		array.RemoveAll();
		line.Remove('[');
		line.Replace(']', ' ');
		line.Remove('(');
		line.Remove(')');
		line.Replace('|', ' ');

		token.Split(line, " ",array);

		if (array.GetSize() > 16)
		{
			TRACE("0: '%s'\n", array[0]);	// num
			TRACE("1: '%s'\n", array[1]);	// ID
			TRACE("2: '%s'\n", array[2]);	// IP/PORT
			TRACE("3: '%s'\n", array[3]);	// version
			TRACE("4: '%s'\n", array[4]);	// rcv
			TRACE("5: '%s'\n", array[5]);	// xmt
			TRACE("6: '%s'\n", array[6]);	// share
			TRACE("7: '%s'\n", array[7]);	// sources header
			TRACE("8: '%s'\n", array[8]);	// sources
			TRACE("9: '%s'\n", array[9]);	// times
			TRACE("10: '%s'\n", array[10]);	// searches
			TRACE("11: '%s'\n", array[11]);	// LowID
			TRACE("12: '%s'\n", array[12]);	// Flags
			TRACE("13: '%s'\n", array[13]);	// 
			TRACE("14: '%s'\n", array[14]);	// 
			TRACE("15: '%s'\n", array[15]);	// 
			TRACE("16: '%s'\n", array[16]);	// nick
			if (array[0] != "num")
			{
				int item = m_Liste.InsertItem(count++,array[0]);
				// ID
				if (array[1].Find("*") != -1)
				{
					array[1].Remove('*');
					bLowId = true;

				}
				m_Liste.SetItemText(item,1,array[1]);
				// nick
				m_Liste.SetItemText(item,2,array[16]);
				// version
				m_Liste.SetItemText(item,3,array[3].Mid(2));
				// LowID
				if (bLowId)
				{
					m_Liste.SetItemText(item,4, "yes");
				}
				else
				{
					m_Liste.SetItemText(item,4, "no");
				}
				// share
				m_Liste.SetItemText(item,5,array[6].Mid(2));
				// searches
				m_Liste.SetItemText(item,6,array[13].Mid(2));
				// Flags
				m_Liste.SetItemText(item,7,array[15].Mid(2));
			}
		}		
	};

	m_Refresh.EnableWindow(TRUE);
	
	return 0;
}

// OnMessage
// ffnen des "Message"-Dialogs
void CUserDlg::OnMessage() 
{
	CSendMessageDlg dlg;
	dlg.DoModal();
}

// CompareItems
// Callbackfunktion der Listensortierung.
// Vergleicht zwei Elemente anhalnd der Spaltennummer miteinander
int CALLBACK CUserDlg::CompareItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORT_PARMS* sp = (SORT_PARMS*)lParamSort;
	CListCtrl* plist = (CListCtrl*)CWnd::FromHandle(sp->hwnd);

	CString item1, item2;
	item1 = plist->GetItemText(lParam1,sp->nCol);
	item2 = plist->GetItemText(lParam2,sp->nCol);

	switch (sp->nCol)
	{
	case 0:	// Nummer
		{
			item1.Delete(0);					// Linke Klammer entfernen
			item2.Delete(0);
			item1.Delete(item1.GetLength() - 1);// Rechte Klammer entfernen
			item2.Delete(item2.GetLength() - 1);

			return (atoi(item1) - atoi(item2));
		}
	case 1:	// IP
		{
			long ip1 = inet_addr(item1);
			long ip2 = inet_addr(item2);

			if ((ip1 & 0x000000FF) < (ip2 & 0x000000FF)) return -1;
			if ((ip1 & 0x000000FF) > (ip2 & 0x000000FF)) return  1;

			if ((ip1 & 0x0000FF00) < (ip2 & 0x0000FF00)) return -1;
			if ((ip1 & 0x0000FF00) > (ip2 & 0x0000FF00)) return  1;

			if ((ip1 & 0x00FF0000) < (ip2 & 0x00FF0000)) return -1;
			if ((ip1 & 0x00FF0000) > (ip2 & 0x00FF0000)) return  1;

			if ((ip1 & 0xFF000000) < (ip2 & 0xFF000000)) return -1;
			if ((ip1 & 0xFF000000) > (ip2 & 0xFF000000)) return  1;
						
			return 0;
		}
	case 2:	// Username
		{
			return item1.CompareNoCase(item2);
		}
	}

	return 0;
}

// OnColumnclickListe
// Klick auf Listenheader : Sortierung starten
void CUserDlg::OnColumnclickListe(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* plv = (NM_LISTVIEW*)pNMHDR;

	SORT_PARMS sparms;
	sparms.nCol = plv->iSubItem;
	sparms.hwnd = m_Liste.GetSafeHwnd();
        
	int nCount = m_Liste.GetItemCount(), lp = 0;
	for (lp=0; lp<nCount; lp++) m_Liste.SetItemData(lp,lp);

	m_Liste.SortItems((PFNLVCOMPARE)CompareItems, (DWORD)&sparms);

	*pResult = 0;
}

// OnRclickListe
// Rechts-Klick auf die Client-Liste : Men ausklappen
// ** auskommentiert **
void CUserDlg::OnRclickListe(NMHDR* pNMHDR, LRESULT* pResult) 
{
	POSITION pos = m_Liste.GetFirstSelectedItemPosition();

	if (pos)
	{
		CMenu menu, *pSubMenu;
		menu.LoadMenu(IDR_CLIENT_MENU);
		
		if (!(pSubMenu = menu.GetSubMenu(0))) return;
		
		CPoint pos;
		GetCursorPos(&pos);
		
		// Popup-Men anzeigen
		::TrackPopupMenu(pSubMenu->m_hMenu, 0, pos.x, pos.y, 0, this->GetSafeHwnd(), NULL);
	}
		
	*pResult = 0;
}

// OnClientDisconnect
// Disconnecten eines verbundenen Clients
// ** auskommentiert **
void CUserDlg::OnClientDisconnect() 
{
	POSITION pos = m_Liste.GetFirstSelectedItemPosition();

	if (pos)
	{
		int item = m_Liste.GetNextSelectedItem(pos);

		// Prfen, auf echte IP-Adresse						
		long inet = inet_addr(m_Liste.GetItemText(item,1));
		if (inet && 0xFF000000)
		{
			CString msg;
			msg.Format(Lang.GetStr(54),m_Liste.GetItemText(item,2));
			
			if (AfxMessageBox(msg,MB_YESNO | MB_ICONQUESTION) == IDYES)
			{
				// Client disconnecten
				CDonkeyCmd* cmd = &((CDonkeyDlg*)GetParent())->m_Donkey;
				
				if (cmd->IsChildRunning())
				{							
					CString nummer = m_Liste.GetItemText(item,0);
					nummer.Delete(0);					  // Linke Klammer entfernen			
					nummer.Delete(nummer.GetLength() - 1);// Rechte Klammer entfernen			
					
					cmd->Execute("d " + nummer ,NULL);

					m_Liste.DeleteAllItems();

					OnRefresh();			
				}
			}
		} else AfxMessageBox(Lang.GetStr(55));
	}
}


void CUserDlg::OnKillfocusEdLimit() 
{
	UpdateData();
}

void CUserDlg::OnKillfocusEdIprange() 
{
	UpdateData();
}
